## linkchecker 6.9

=== Makefile ===
# This Makefile is only used by developers.
PYVER:=2.7
PYTHON:=python$(PYVER)
VERSION:=$(shell $(PYTHON) setup.py --version)
PLATFORM:=$(shell $(PYTHON) -c "from distutils.util import get_platform; print get_platform()")
FILESCHECK_URL:=http://localhost/~calvin/
PYTHONSRC:=${HOME}/src/cpython-hg/Lib
#PYTHONSRC:=/usr/lib/$(PYTHON)
PY_FILES_DIRS:=linkcheck tests *.py linkchecker linkchecker-gui cgi-bin config doc
TESTS ?= tests/
# set test options, eg. to "--nologcapture"
TESTOPTS=
PAGER ?= less
# build dir for debian package
BUILDDIR:=$(HOME)/packages/official
DEB_ORIG_TARGET:=$(BUILDDIR)/linkchecker_$(VERSION).orig.tar.bz2
# original dnspython repository module
DNSPYTHON:=$(HOME)/src/dnspython-git/dns
# options to run the pep8 utility
PEP8OPTS:=--repeat --ignore=E211,E501,E225,E301,E302,E241 \
   --exclude="dns,gzip2.py,httplib2.py,robotparser2.py,reindent.py"
PY2APPOPTS ?=


.PHONY: all
all:
	@echo "Read the file doc/install.txt to see how to build and install this package."

.PHONY: clean
clean:
	-$(PYTHON) setup.py clean --all
	rm -f linkchecker-out.* *-stamp*
	$(MAKE) -C po clean
	$(MAKE) -C doc/html clean
	$(MAKE) -C linkcheck/HtmlParser clean
	rm -f linkcheck/network/_network*.so
	find . -name '*.py[co]' -exec rm -f {} \;

.PHONY: distclean
distclean: clean cleandeb
	rm -rf build dist linkchecker.egg-info
	rm -f _LinkChecker_configdata.py MANIFEST Packages.gz
# clean aborted dist builds and -out files
	rm -f linkchecker-out* linkchecker.prof
	rm -rf LinkChecker-$(VERSION)
	rm -rf coverage dist-stamp python-build-stamp*

.PHONY: cleandeb
cleandeb:
	rm -rf debian/linkchecker debian/tmp
	rm -f debian/*.debhelper debian/{files,substvars}
	rm -f configure-stamp build-stamp

MANIFEST: MANIFEST.in setup.py
	$(PYTHON) setup.py sdist --manifest-only

.PHONY: locale
locale:
	$(MAKE) -C po

# to build in the current directory
.PHONY: localbuild
localbuild: MANIFEST
	$(MAKE) -C doc/html
	$(MAKE) -C linkcheck/HtmlParser
	$(PYTHON) setup.py build
	cp -f build/lib.$(PLATFORM)-$(PYVER)/linkcheck/HtmlParser/htmlsax*.so linkcheck/HtmlParser
	cp -f build/lib.$(PLATFORM)-$(PYVER)/linkcheck/network/_network*.so linkcheck/network

.PHONY: deb_orig
deb_orig:
	if [ ! -e $(DEB_ORIG_TARGET) ]; then \
	  $(MAKE) dist-stamp && \
	  cp dist/LinkChecker-$(VERSION).tar.bz2 $(DEB_ORIG_TARGET); \
	fi

.PHONY: upload
upload:
	rsync -avP -e ssh dist/* calvin,linkchecker@frs.sourceforge.net:/home/frs/project/l/li/linkchecker/$(VERSION)/


.PHONY: release
release: distclean releasecheck dist-stamp sign_distfiles upload
	git tag v$(VERSION)
	@echo "Updating LinkChecker Homepage..."
	sed -i -e "s/version = '.*'/version = '$(VERSION)'/" ~/public_html/linkchecker.sf.net/source/conf.py
	$(MAKE) -C ~/public_html/linkchecker.sf.net update upload
	@echo "Register at Python Package Index..."
	$(PYTHON) setup.py register
	wget -O - http://pypants.org/projects/linkchecker/update/ > /dev/null
	freshmeat-submit < linkchecker.freshmeat

.PHONY: chmod
chmod:
	-chmod -R a+rX,u+w,go-w -- *
	find . -type d -exec chmod 755 {} \;

.PHONY: dist
dist: locale MANIFEST chmod
	$(PYTHON) setup.py sdist --formats=bztar
# no rpm buildable with bdist_rpm, presumable due to this bug:
# https://bugzilla.redhat.com/show_bug.cgi?id=236535
# too uninvolved to fix it

dist-stamp: changelog
	$(MAKE) dist
	touch $@

# Build OSX installer
.PHONY: app
app: distclean localbuild chmod
	$(PYTHON) setup.py py2app $(PY2APPOPTS)

# The check programs used here are mostly local scripts on my private system.
# So for other developers there is no need to execute this target.
.PHONY: check
check:
	[ ! -d .svn ] || check-nosvneolstyle -v
	check-copyright
	check-pofiles -v
	py-tabdaddy
	py-unittest2-compat tests/
	$(MAKE) doccheck
	$(MAKE) pyflakes

doccheck:
	py-check-docstrings --force linkcheck/HtmlParser linkcheck/checker \
	  linkcheck/cache linkcheck/configuration linkcheck/director \
	  linkcheck/htmlutil linkcheck/logger linkcheck/network \
	  linkcheck/bookmarks \
	  linkcheck/gui/__init__.py \
	  linkcheck/gui/checker.py \
	  linkcheck/gui/contextmenu.py \
	  linkcheck/gui/debug.py \
	  linkcheck/gui/editor.py \
	  linkcheck/gui/editor_qsci.py \
	  linkcheck/gui/editor_qt.py \
	  linkcheck/gui/lineedit.py \
	  linkcheck/gui/help.py \
	  linkcheck/gui/logger.py \
	  linkcheck/gui/options.py \
	  linkcheck/gui/progress.py \
	  linkcheck/gui/properties.py \
	  linkcheck/gui/settings.py \
	  linkcheck/gui/statistics.py \
	  linkcheck/gui/syntax.py \
	  linkcheck/gui/updater.py \
	  linkcheck/gui/urlmodel.py \
	  linkcheck/gui/urlsave.py \
	  linkcheck/__init__.py \
	  linkcheck/ansicolor.py \
	  linkcheck/clamav.py \
	  linkcheck/containers.py \
	  linkcheck/cookies.py \
	  linkcheck/decorators.py \
	  linkcheck/dummy.py \
	  linkcheck/fileutil.py \
	  linkcheck/ftpparse.py \
	  linkcheck/geoip.py \
	  linkcheck/httputil.py \
	  linkcheck/i18n.py \
	  linkcheck/lc_cgi.py \
	  linkcheck/lock.py \
	  linkcheck/log.py \
	  linkcheck/mem.py \
	  linkcheck/robotparser2.py \
	  linkcheck/socketutil.py \
	  linkcheck/strformat.py \
	  linkcheck/threader.py \
	  linkcheck/trace.py \
	  linkcheck/updater.py \
	  linkcheck/url.py \
	  linkcheck/winutil.py \
	  *.py

filescheck:
	for out in text html gml sql csv xml gxml dot; do \
	  ./linkchecker -o$$out -F$$out --complete -r1 -C $(FILESCHECK_URL) || exit 1; \
	done

update-copyright:
	update-copyright --holder="Bastian Kleineidam"

.PHONY: releasecheck
releasecheck: check
	@if egrep -i "xx\.|xxxx|\.xx" doc/changelog.txt > /dev/null; then \
	  echo "Could not release: edit doc/changelog.txt release date"; false; \
	fi
	@if ! grep "Version: $(VERSION)" linkchecker.freshmeat > /dev/null; then \
	  echo "Could not release: edit linkchecker.freshmeat version"; false; \
	fi
#	$(MAKE) -C doc test

.PHONY: sign_distfiles
sign_distfiles:
	for f in $(shell find dist -name *.bz2 -o -name *.exe -o -name *.zip -o -name *.dmg); do \
	  [ -f $${f}.asc ] || gpg --detach-sign --armor $$f; \
	done

.PHONY: test
test:	localbuild
	$(PYTHON) $(shell which nosetests) -v -m "^test_.*" $(TESTOPTS) $(TESTS)

.PHONY: pyflakes
pyflakes:
	pyflakes --force $(PY_FILES_DIRS) 2>&1 | \
          grep -v "redefinition of unused 'linkcheck'" | \
          grep -v "undefined name '_'" | \
	  grep -v "undefined name '_n'" | cat

.PHONY: pep8
pep8:
	pep8 $(PEP8OPTS) $(PY_FILES_DIRS)

.PHONY: reindent
reindent:
	$(PYTHON) config/reindent.py -r -v linkcheck

# Compare custom Python files with the original ones from subversion.
.PHONY: diff
diff:
	@for f in gzip robotparser httplib; do \
	  echo "Comparing $${f}.py"; \
	  diff -u linkcheck/$${f}2.py $(PYTHONSRC)/$${f}.py | $(PAGER); \
	done

.PHONY: dnsdiff
dnsdiff:
	diff -BurN --exclude=changelog.txt linkcheck/dns $(DNSPYTHON) | $(PAGER)

.PHONY: changelog
changelog:
	sftrack_changelog linkchecker calvin@users.sourceforge.net doc/changelog.txt

.PHONY: gui
gui:
	$(MAKE) -C linkcheck/gui

.PHONY: count
count:
	@sloccount linkchecker linkchecker-gui linkcheck | grep "Total Physical Source Lines of Code"

=== linkcheck/gui/Makefile ===
# generate Python files from UI description

# edit ui/*.ui files with designer (ie. /usr/bin/designer-qt4)
UI_FILES = linkchecker_ui_main.py \
	linkchecker_ui_options.py \
	linkchecker_ui_progress.py \
	linkchecker_ui_debug.py \
	linkchecker_ui_editor.py
RC_FILES = linkchecker_rc.py


all: $(UI_FILES) $(RC_FILES)

linkchecker_ui_%.py: ui/%.ui
	pyuic4 -o $@ $<
# replace the Qt translator with the one LinkChecker uses
	sed -i -r -e 's/QtGui\.QApplication\.translate\("[^"]+", "([^"]+)", None, QtGui\.QApplication\.UnicodeUTF8\)/_("\1")/g' $@

linkchecker_rc.py: rc/linkchecker.qrc
	pyrcc4 -o $@ $<

clean:
	rm -f *.pyc *.pyo

rebuild:
	rm -f $(UI_FILES) $(RC_FILES)
	$(MAKE) all

=== linkcheck/gui/rc/Makefile ===
# refresh media files

# base directory of oxygen icon set checkout
OXYGEN = $(HOME)/src/oxygen-gitsvn/16x16

ICONS = \
	cancel.png \
	online.png \
	options.png \
	preferences.png \
	save.png \
	start.png \
	stop.png \
	about.png \
	help.png \
	exit.png \
	copy.png \
	clear.png

all: $(ICONS)

app.png:	$(OXYGEN)/categories/applications-development-web.png
	cp $< $@

save.png:	$(OXYGEN)/actions/document-save-as.png
	cp $< $@

start.png:	$(OXYGEN)/actions/media-playback-start.png
	cp $< $@

stop.png:	$(OXYGEN)/actions/media-playback-stop.png
	cp $< $@

cancel.png:	$(OXYGEN)/actions/process-stop.png
	cp $< $@

about.png:	$(OXYGEN)/actions/help-about.png
	cp $< $@

help.png:	$(OXYGEN)/actions/help-contents.png
	cp $< $@

exit.png:	$(OXYGEN)/actions/application-exit.png
	cp $< $@

copy.png:	$(OXYGEN)/actions/edit-copy.png
	cp $< $@

online.png:	$(OXYGEN)/actions/document-open-remote.png
	cp $< $@

options.png:	$(OXYGEN)/categories/preferences-system-network.png
	cp $< $@

preferences.png:	$(OXYGEN)/categories/preferences-other.png
	cp $< $@

clear.png:	$(OXYGEN)/actions/edit-clear-locationbar-rtl.png
	cp $< $@

clean:
	rm -f *.png

=== debian/changelog ===
linkchecker (6.9-1) unstable; urgency=low

  * New upstream release.
  * Move python-qscintilla2 from depends to recommends.
  * Use hardening-wrapper for compiling C extensions.

 -- Bastian Kleineidam <calvin@debian.org>  Sun, 01 May 2011 11:45:52 +0200

## linkchecker 7.0

=== Makefile ===
--- 
+++ 
@@ -15,11 +15,16 @@
 BUILDDIR:=$(HOME)/packages/official
 DEB_ORIG_TARGET:=$(BUILDDIR)/linkchecker_$(VERSION).orig.tar.bz2
 # original dnspython repository module
-DNSPYTHON:=$(HOME)/src/dnspython-git/dns
+DNSPYTHON:=$(HOME)/src/dnspython-git
 # options to run the pep8 utility
 PEP8OPTS:=--repeat --ignore=E211,E501,E225,E301,E302,E241 \
-   --exclude="dns,gzip2.py,httplib2.py,robotparser2.py,reindent.py"
+   --exclude="gzip2.py,httplib2.py,robotparser2.py,reindent.py"
 PY2APPOPTS ?=
+ifeq ($(shell uname),Darwin)
+  NUMPROCESSORS:=$(shell sysctl -a | grep machdep.cpu.core_count | cut -d " " -f 2)
+else
+  NUMPROCESSORS:=$(shell grep -c processor /proc/cpuinfo)
+endif
 
 
 .PHONY: all
@@ -139,7 +144,6 @@
 	  linkcheck/gui/help.py \
 	  linkcheck/gui/logger.py \
 	  linkcheck/gui/options.py \
-	  linkcheck/gui/progress.py \
 	  linkcheck/gui/properties.py \
 	  linkcheck/gui/settings.py \
 	  linkcheck/gui/statistics.py \
@@ -199,7 +203,8 @@
 
 .PHONY: test
 test:	localbuild
-	$(PYTHON) $(shell which nosetests) -v -m "^test_.*" $(TESTOPTS) $(TESTS)
+	$(PYTHON) $(shell which nosetests) --processes=$(NUMPROCESSORS) \
+	  -v -m "^test_.*" $(TESTOPTS) $(TESTS)
 
 .PHONY: pyflakes
 pyflakes:
@@ -224,13 +229,16 @@
 	  diff -u linkcheck/$${f}2.py $(PYTHONSRC)/$${f}.py | $(PAGER); \
 	done
 
+# Compare dnspython files with the ones from upstream repository
 .PHONY: dnsdiff
 dnsdiff:
-	diff -BurN --exclude=changelog.txt linkcheck/dns $(DNSPYTHON) | $(PAGER)
+	@(for d in dns tests; do \
+	  diff -BurN --exclude=*.pyc third_party/dnspython/$$d $(DNSPYTHON)/$$d; \
+	done) | $(PAGER)
 
 .PHONY: changelog
 changelog:
-	sftrack_changelog linkchecker calvin@users.sourceforge.net doc/changelog.txt
+	sftrack_changelog linkchecker calvin@users.sourceforge.net doc/changelog.txt $(DRYRUN)
 
 .PHONY: gui
 gui:
@@ -239,3 +247,8 @@
 .PHONY: count
 count:
 	@sloccount linkchecker linkchecker-gui linkcheck | grep "Total Physical Source Lines of Code"
+
+# run eclipse ide
+.PHONY: ide
+ide:
+	eclipse-3.6 -data $(CURDIR)/..

=== po/Makefile ===
XGETTEXT := xgettext
MSGFMT := msgfmt
MSGMERGE := msgmerge
POSOURCES = $(shell find ../linkcheck -name \*.py) \
	../linkchecker ../linkchecker-gui /usr/lib/python2.6/optparse.py
LDIR = ../share/locale
PACKAGE = linkchecker
TEMPLATE = $(PACKAGE).pot
MYMAIL := calvin@users.sourceforge.net
LFILE = LC_MESSAGES/$(PACKAGE).mo
# defined language (add new languages here)
LANGUAGES = de fr es

all:

mofiles:
	@for la in $(LANGUAGES); do \
	  if [ ! -d $(LDIR)/$$la/LC_MESSAGES ]; then \
	    mkdir -p $(LDIR)/$$la/LC_MESSAGES; \
	  fi; \
	  echo "Formatting language catalog $${la}:"; \
	  $(MSGFMT) -c --statistics -o $(LDIR)/$$la/$(LFILE) $$la.po; \
	done

%.po:	$(TEMPLATE)
	$(MSGMERGE) -U --suffix=.bak $@ $<

template: $(TEMPLATE)
$(TEMPLATE): $(POSOURCES)
	$(XGETTEXT) -w 80 --default-domain=$(PACKAGE) --language=Python \
	  --copyright-holder="Bastian Kleineidam <$(MYMAIL)>" \
	  --msgid-bugs-address=$(MYMAIL) -o $(TEMPLATE) \
	  --keyword=_n:1,2 $(POSOURCES)

%.mo:	%.po
	if [ ! -d $(LDIR)/$*/LC_MESSAGES ]; then \
	  mkdir -p $(LDIR)/$*/LC_MESSAGES; \
	fi
	$(MSGFMT) -c --statistics -o $(LDIR)/$*/$(LFILE) $<

clean:
	@for f in $(LANGUAGES); do rm -f $(LDIR)/$$f/$(LFILE); done
	rm -f *.mo *.bak

.PHONY: mofiles clean

=== third_party/dnspython/tests/Makefile ===
# Copyright (C) 2003-2007, 2009-2011 Nominum, Inc.
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose with or without fee is hereby granted,
# provided that the above copyright notice and this permission notice
# appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND NOMINUM DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL NOMINUM BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
# OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

# $Id: Makefile,v 1.5 2004/03/19 00:17:27 halley Exp $

PYTHON=python

check: test

test:
	@for i in *.py; do \
		echo "Running $$i:"; \
		PYTHONPATH=.. ${PYTHON} $$i || exit 1; \
	done

## linkchecker 7.1

=== Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 TESTOPTS=
 PAGER ?= less
 # build dir for debian package
-BUILDDIR:=$(HOME)/packages/official
+BUILDDIR:=$(HOME)/projects/debian/official
 DEB_ORIG_TARGET:=$(BUILDDIR)/linkchecker_$(VERSION).orig.tar.bz2
 # original dnspython repository module
 DNSPYTHON:=$(HOME)/src/dnspython-git
@@ -88,6 +88,7 @@
 release: distclean releasecheck dist-stamp sign_distfiles upload
 	git tag v$(VERSION)
 	@echo "Updating LinkChecker Homepage..."
+	$(MAKE) -C doc man
 	sed -i -e "s/version = '.*'/version = '$(VERSION)'/" ~/public_html/linkchecker.sf.net/source/conf.py
 	$(MAKE) -C ~/public_html/linkchecker.sf.net update upload
 	@echo "Register at Python Package Index..."

## linkchecker 7.2

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 DNSPYTHON:=$(HOME)/src/dnspython-git
 # options to run the pep8 utility
 PEP8OPTS:=--repeat --ignore=E211,E501,E225,E301,E302,E241 \
-   --exclude="gzip2.py,httplib2.py,robotparser2.py,reindent.py"
+   --exclude="gzip2.py,httplib2.py,robotparser2.py"
 PY2APPOPTS ?=
 ifeq ($(shell uname),Darwin)
   NUMPROCESSORS:=$(shell sysctl -a | grep machdep.cpu.core_count | cut -d " " -f 2)
@@ -93,7 +93,6 @@
 	$(MAKE) -C ~/public_html/linkchecker.sf.net update upload
 	@echo "Register at Python Package Index..."
 	$(PYTHON) setup.py register
-	wget -O - http://pypants.org/projects/linkchecker/update/ > /dev/null
 	freshmeat-submit < linkchecker.freshmeat
 
 .PHONY: chmod
@@ -218,10 +217,6 @@
 pep8:
 	pep8 $(PEP8OPTS) $(PY_FILES_DIRS)
 
-.PHONY: reindent
-reindent:
-	$(PYTHON) config/reindent.py -r -v linkcheck
-
 # Compare custom Python files with the original ones from subversion.
 .PHONY: diff
 diff:

=== doc/Makefile ===
HTMLDIR:=$(HOME)/public_html/linkchecker.sf.net/source
MANFILES:= \
	$(HTMLDIR)/man1/linkchecker.1.html \
	$(HTMLDIR)/man5/linkcheckerrc.5.html \
	$(HTMLDIR)/man1/linkchecker-gui.1.html

all:

po4a:
	po4a --localized-charset=UTF-8 po4a.conf

man:	$(MANFILES)

$(HTMLDIR)/man1/linkchecker.1.html: en/linkchecker.1 linkchecker.1.html.diff
	man2html -r $< | tail -n +2 | sed 's/Time:.*//g' > $@
	patch --no-backup-if-mismatch --quiet $@ linkchecker.1.html.diff

$(HTMLDIR)/man5/linkcheckerrc.5.html: en/linkcheckerrc.5 linkcheckerrc.5.html.diff
	man2html -r $< | tail -n +2 | sed 's/Time:.*//g' > $@
	patch --no-backup-if-mismatch --quiet $@ linkcheckerrc.5.html.diff

$(HTMLDIR)/man1/linkchecker-gui.1.html: en/linkchecker-gui.1 linkchecker-gui.1.html.diff
	man2html -r $< | tail -n +2 | sed 's/Time:.*//g' > $@
	patch --no-backup-if-mismatch --quiet $@ linkchecker-gui.1.html.diff

.PHONY: po4a man

=== debian/changelog ===
linkchecker (7.2-1) unstable; urgency=low

  * New upstream release.

 -- Bastian Kleineidam <calvin@debian.org>  Thu, 20 Oct 2011 10:17:49 +0200

linkchecker (7.1-1) unstable; urgency=low

  * New upstream release.

 -- Bastian Kleineidam <calvin@debian.org>  Sat, 28 May 2011 12:45:43 +0200

linkchecker (7.0-1) unstable; urgency=low

  * New upstream release.
  * Added conflict to python-dnspython since linkchecker installs
    a patched version of that module.

 -- Bastian Kleineidam <calvin@debian.org>  Sat, 07 May 2011 14:01:23 +0200

## linkchecker 7.3

=== debian/changelog ===
linkchecker (7.3-1) unstable; urgency=low

  * New upstream release.

 -- Bastian Kleineidam <calvin@debian.org>  Sat, 05 Nov 2011 13:33:47 +0100

=== debian/control ===
Source: linkchecker
Section: web
Priority: optional
Maintainer: Bastian Kleineidam <calvin@debian.org>
Build-Depends: debhelper (>= 7.0.50),
               gettext,
               hardening-wrapper,
               python-all-dev (>= 2.6.6-3),
               qt4-dev-tools
X-Python-Version: >= 2.6
Standards-Version: 3.9.2
Homepage: http://linkchecker.sourceforge.net/
Vcs-Git: git://linkchecker.git.sourceforge.net/gitroot/linkchecker/linkchecker
Vcs-Browser: http://linkchecker.git.sourceforge.net/

Package: linkchecker
Architecture: any
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Provides: ${python:Provides}
Conflicts: python-dnspython
Suggests: apache2 | httpd,
          clamav-daemon,
          linkchecker-gui,
          python-cssutils,
          python-gconf,
          python-geoip (>= 1.2.1-2),
          python-optcomplete (>= 1.2-5),
          python-pysqlite2,
          python-twill,
          python-utidylib
Description: check websites and HTML documents for broken links
 Provides a command line program and web interface to check links
 of websites and HTML documents.
 Features:
  o recursive checking
  o multithreaded
  o output in colored or normal text, HTML, SQL, CSV, XML or a sitemap
    graph in different formats
  o HTTP/1.1, HTTPS, FTP, mailto:, news:, nntp:, Telnet and local file
    links support
  o restrict link checking with regular expression filters for URLs
  o proxy support
  o username/password authorization for HTTP, FTP and Telnet
  o robots.txt exclusion protocol support
  o Cookie support
  o i18n support
  o HTML and CSS syntax check
  o Antivirus check
 Users preferring a graphical interface can install the linkchecker-gui
 package.

Package: linkchecker-gui
Architecture: all
Depends: libqt4-sql-sqlite,
         linkchecker,
         python-qt4 (>= 4.5),
         ${misc:Depends},
         ${python:Depends}
Recommends: python-qscintilla2
Description: check websites and HTML documents for broken links (GUI client)
 Provides a graphical interface "linkchecker-gui" to check links of websites
 and HTML documents.
 Features:
  o recursive checking
  o multithreaded
  o HTTP/1.1, HTTPS, FTP, mailto:, news:, nntp:, Telnet and local file
    links support
  o proxy support
  o username/password authorization for HTTP, FTP and Telnet
  o robots.txt exclusion protocol support
  o i18n support

## linkchecker 7.4

=== Makefile ===
--- 
+++ 
@@ -21,11 +21,14 @@
    --exclude="gzip2.py,httplib2.py,robotparser2.py"
 PY2APPOPTS ?=
 ifeq ($(shell uname),Darwin)
+  NOSETESTS:=/usr/local/share/python/nosetests
   NUMPROCESSORS:=$(shell sysctl -a | grep machdep.cpu.core_count | cut -d " " -f 2)
+  CHMODMINUSMINUS:=
 else
+  NOSETESTS:=$(shell which nosetests)
   NUMPROCESSORS:=$(shell grep -c processor /proc/cpuinfo)
+  CHMODMINUSMINUS:=--
 endif
-
 
 .PHONY: all
 all:
@@ -93,11 +96,11 @@
 	$(MAKE) -C ~/public_html/linkchecker.sf.net update upload
 	@echo "Register at Python Package Index..."
 	$(PYTHON) setup.py register
-	freshmeat-submit < linkchecker.freshmeat
+	freecode-submit < linkchecker.freecode
 
 .PHONY: chmod
 chmod:
-	-chmod -R a+rX,u+w,go-w -- *
+	-chmod -R a+rX,u+w,go-w $(CHMODMINUSMINUS) *
 	find . -type d -exec chmod 755 {} \;
 
 .PHONY: dist
@@ -175,6 +178,8 @@
 	  linkcheck/updater.py \
 	  linkcheck/url.py \
 	  linkcheck/winutil.py \
+	  linkchecker \
+	  linkchecker-gui \
 	  *.py
 
 filescheck:
@@ -190,8 +195,8 @@
 	@if egrep -i "xx\.|xxxx|\.xx" doc/changelog.txt > /dev/null; then \
 	  echo "Could not release: edit doc/changelog.txt release date"; false; \
 	fi
-	@if ! grep "Version: $(VERSION)" linkchecker.freshmeat > /dev/null; then \
-	  echo "Could not release: edit linkchecker.freshmeat version"; false; \
+	@if ! grep "Version: $(VERSION)" linkchecker.freecode > /dev/null; then \
+	  echo "Could not release: edit linkchecker.freecode version"; false; \
 	fi
 #	$(MAKE) -C doc test
 
@@ -203,12 +208,12 @@
 
 .PHONY: test
 test:	localbuild
-	$(PYTHON) $(shell which nosetests) --processes=$(NUMPROCESSORS) \
+	$(PYTHON) $(NOSETESTS) --processes=$(NUMPROCESSORS) \
 	  -v -m "^test_.*" $(TESTOPTS) $(TESTS)
 
 .PHONY: pyflakes
 pyflakes:
-	pyflakes --force $(PY_FILES_DIRS) 2>&1 | \
+	pyflakes $(PY_FILES_DIRS) 2>&1 | \
           grep -v "redefinition of unused 'linkcheck'" | \
           grep -v "undefined name '_'" | \
 	  grep -v "undefined name '_n'" | cat
@@ -247,4 +252,4 @@
 # run eclipse ide
 .PHONY: ide
 ide:
-	eclipse-3.6 -data $(CURDIR)/..
+	eclipse -data $(CURDIR)/..

=== debian/changelog ===
linkchecker (7.4-1) unstable; urgency=low

  * New upstream release.
    + Requires Python >= 2.7
    + Remove old conffile /etc/linkchecker/logging.conf
  * Use debhelper v8.

 -- Bastian Kleineidam <calvin@debian.org>  Mon, 02 Jan 2012 12:25:46 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_HARDENING=1

%:
	dh $@ --with python2

override_dh_auto_configure:
# make sure docs are generated and the manifest is built
	$(MAKE) locale
	$(MAKE) -C doc/html all
	python setup.py sdist --manifest-only

override_dh_auto_build:
# force usage of setup.py over Makefile
	dh_auto_build --buildsystem python_distutils

override_dh_installchangelogs:
# install custom changelog
	dh_installchangelogs doc/changelog.txt


ROOTDIR=$(CURDIR)/debian/linkchecker
HTMLDIR=$(ROOTDIR)/usr/share/linkchecker/lconline
CGIDIR=$(ROOTDIR)/usr/lib/cgi-bin
LOCALEDIR=$(ROOTDIR)/usr/share/locale
ETCDIR=$(ROOTDIR)/etc

override_dh_auto_install:
	dh_auto_install --buildsystem python_distutils
# install system wide configuration files in etc
	install -m 644 config/linkcheckerrc $(ETCDIR)/linkchecker/
# install CGI files
	install -m 644 cgi-bin/lconline/*.html $(HTMLDIR)
	install -m 644 cgi-bin/lconline/*.de $(HTMLDIR)
	install -m 644 cgi-bin/lconline/*.en $(HTMLDIR)
	install -m 644 cgi-bin/lconline/*.js $(HTMLDIR)
	install -m 644 cgi-bin/lconline/*.css $(HTMLDIR)
	install -m 644 cgi-bin/lconline/*.ico $(HTMLDIR)
	install -m 755 cgi-bin/lc.cgi $(CGIDIR)
# install bash_completion script
	install -m 644 config/linkchecker-completion $(ETCDIR)/bash_completion.d
# install .mo files
	install -m 644 build/share/locale/de/LC_MESSAGES/LinkChecker.mo $(LOCALEDIR)/de/LC_MESSAGES/
# apache configuration
	install -m 644 config/linkchecker.apache2.conf $(ETCDIR)/apache2/conf.d/linkchecker

# clean generated files
override_dh_clean:
	dh_clean doc/html/*.qch doc/html/*.qhc _LinkChecker_configdata.py

# do not run test suite when building
override_dh_auto_test:

## linkchecker 7.6

=== Makefile ===
--- 
+++ 
@@ -22,11 +22,9 @@
 PY2APPOPTS ?=
 ifeq ($(shell uname),Darwin)
   NOSETESTS:=/usr/local/share/python/nosetests
-  NUMPROCESSORS:=$(shell sysctl -a | grep machdep.cpu.core_count | cut -d " " -f 2)
   CHMODMINUSMINUS:=
 else
   NOSETESTS:=$(shell which nosetests)
-  NUMPROCESSORS:=$(shell grep -c processor /proc/cpuinfo)
   CHMODMINUSMINUS:=--
 endif
 
@@ -198,7 +196,7 @@
 	@if ! grep "Version: $(VERSION)" linkchecker.freecode > /dev/null; then \
 	  echo "Could not release: edit linkchecker.freecode version"; false; \
 	fi
-#	$(MAKE) -C doc test
+	$(PYTHON) setup.py check --restructuredtext
 
 .PHONY: sign_distfiles
 sign_distfiles:
@@ -208,8 +206,7 @@
 
 .PHONY: test
 test:	localbuild
-	$(PYTHON) $(NOSETESTS) --processes=$(NUMPROCESSORS) \
-	  -v -m "^test_.*" $(TESTOPTS) $(TESTS)
+	$(PYTHON) $(NOSETESTS) -v -m "^test_.*" $(TESTOPTS) $(TESTS)
 
 .PHONY: pyflakes
 pyflakes:

=== debian/changelog ===
linkchecker (7.6-1) unstable; urgency=low

  * New upstream release.
  * Updated Standards Version to 3.9.3.
  * Do not fail in postinst on Apache2 configuration errors.

 -- Bastian Kleineidam <calvin@debian.org>  Sat, 31 Mar 2012 14:13:17 +0200

linkchecker (7.5-1) unstable; urgency=low

  * New upstream release.

 -- Bastian Kleineidam <calvin@debian.org>  Mon, 09 Jan 2012 20:51:38 +0100

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: web
 Priority: optional
 Maintainer: Bastian Kleineidam <calvin@debian.org>
-Build-Depends: debhelper (>= 7.0.50),
+Build-Depends: debhelper (>= 8),
                gettext,
                hardening-wrapper,
-               python-all-dev (>= 2.6.6-3),
+               python-all-dev (>= 2.7),
                qt4-dev-tools
-X-Python-Version: >= 2.6
-Standards-Version: 3.9.2
+X-Python-Version: >= 2.7
+Standards-Version: 3.9.3
 Homepage: http://linkchecker.sourceforge.net/
 Vcs-Git: git://linkchecker.git.sourceforge.net/gitroot/linkchecker/linkchecker
 Vcs-Browser: http://linkchecker.git.sourceforge.net/

## linkchecker 7.7

=== Makefile ===
--- 
+++ 
@@ -44,7 +44,7 @@
 
 .PHONY: distclean
 distclean: clean cleandeb
-	rm -rf build dist linkchecker.egg-info
+	rm -rf build dist LinkChecker.egg-info
 	rm -f _LinkChecker_configdata.py MANIFEST Packages.gz
 # clean aborted dist builds and -out files
 	rm -f linkchecker-out* linkchecker.prof
@@ -62,11 +62,11 @@
 
 .PHONY: locale
 locale:
-	$(MAKE) -C po
+	$(MAKE) -C po mofiles
 
 # to build in the current directory
 .PHONY: localbuild
-localbuild: MANIFEST
+localbuild: MANIFEST locale
 	$(MAKE) -C doc/html
 	$(MAKE) -C linkcheck/HtmlParser
 	$(PYTHON) setup.py build
@@ -176,6 +176,7 @@
 	  linkcheck/updater.py \
 	  linkcheck/url.py \
 	  linkcheck/winutil.py \
+	  cgi-bin/lc.wsgi \
 	  linkchecker \
 	  linkchecker-gui \
 	  *.py

=== debian/changelog ===
linkchecker (7.7-2) unstable; urgency=low

  * Fix FTBFS when building only architecture dependant packages.
    Closes: #670313

 -- Bastian Kleineidam <calvin@debian.org>  Wed, 25 Apr 2012 06:54:11 +0200

linkchecker (7.7-1) unstable; urgency=low

  * New upstream release.
  * Add new package linkchecker-web which provides the
    web interface. Do not bundle it with the command line
    client because then linkchecker would depend on web
    servers and the PyQt libraries.
  * Make linkchecker-web compatible with Apache 2.2 and 2.4.

 -- Bastian Kleineidam <calvin@debian.org>  Sun, 22 Apr 2012 20:48:03 +0200

## linkchecker 7.8

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # This Makefile is only used by developers.
 PYVER:=2.7
-PYTHON:=python$(PYVER)
+PYTHON?=python$(PYVER)
 VERSION:=$(shell $(PYTHON) setup.py --version)
 PLATFORM:=$(shell $(PYTHON) -c "from distutils.util import get_platform; print get_platform()")
 FILESCHECK_URL:=http://localhost/~calvin/
@@ -86,7 +86,7 @@
 
 
 .PHONY: release
-release: distclean releasecheck dist-stamp sign_distfiles upload
+release: distclean releasecheck filescheck clean dist-stamp sign_distfiles upload
 	git tag v$(VERSION)
 	@echo "Updating LinkChecker Homepage..."
 	$(MAKE) -C doc man
@@ -181,7 +181,7 @@
 	  linkchecker-gui \
 	  *.py
 
-filescheck:
+filescheck: localbuild
 	for out in text html gml sql csv xml gxml dot; do \
 	  ./linkchecker -o$$out -F$$out --complete -r1 -C $(FILESCHECK_URL) || exit 1; \
 	done

## linkchecker 7.9

=== Makefile ===
--- 
+++ 
@@ -112,10 +112,17 @@
 	$(MAKE) dist
 	touch $@
 
-# Build OSX installer
+# Build OSX installer with py2app
 .PHONY: app
 app: distclean localbuild chmod
 	$(PYTHON) setup.py py2app $(PY2APPOPTS)
+
+# Build RPM installer with cx_Freeze
+.PHONY: rpm
+rpm:
+	$(MAKE) -C doc/html
+	$(MAKE) -C linkcheck/HtmlParser
+	$(PYTHON) setup.py bdist_rpm
 
 # The check programs used here are mostly local scripts on my private system.
 # So for other developers there is no need to execute this target.

=== po/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 MSGFMT := msgfmt
 MSGMERGE := msgmerge
 POSOURCES = $(shell find ../linkcheck -name \*.py) \
-	../linkchecker ../linkchecker-gui /usr/lib/python2.6/optparse.py
+	../linkchecker ../linkchecker-gui /usr/lib/python2.7/optparse.py
 LDIR = ../share/locale
 PACKAGE = linkchecker
 TEMPLATE = $(PACKAGE).pot

=== doc/html/Makefile ===
HELPFILES := lccollection.qhc
HTMLFILES := index.html options.html
OXYGEN := ${HOME}/src/oxygen-gitsvn
ICOICONS := logo16x16.png logo32x32.png
ICNSICONS := logo16x16.png logo32x32.png logo48x48.png logo128x128.png

all:	$(HELPFILES) $(HTMLFILES)

.PHONY: clean
clean:
	-rm -f *.qhc *.qch

%.html:	%.txt html.header html.footer
	(cat html.header; markdown2 $<; cat html.footer) > $@

.PHONY: clean
test:
	xmllint --valid --noout $(HTMLFILES)

%.qhc:	%.qhcp lcdoc.qhp $(HTMLFILES)
	qcollectiongenerator $< -o $@

logo%.png:	$(OXYGEN)/%/categories/applications-development-web.png
	cp $< $@

favicon.ico:	$(ICOICONS)
	png2ico favicon.ico $(ICOICONS)

favicon.icns:	$(ICNSICONS)
	png2icns favicon.icns $(ICNSICONS)

=== debian/changelog ===
linkchecker (7.9-2.2) unstable; urgency=low

  * Non-maintainer upload.
  * Brown bag NMU, preview patch was wrong
  * This will still work with either python version, by catching the
    exception if the removed lists are missing (Closes: #681069) (really)

 -- Scott Kitterman <scott@kitterman.com>  Tue, 24 Jul 2012 00:46:43 -0400

linkchecker (7.9-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Add url definition lists deleted from Python's urlparser.py to
    linkcheckers' linkcheck/url.py and refer to the local copies to fix three
    sources of crashes (the Python versions are present in 2.7.3~rc2 and
    missing from 2.7.3 final - this patched version will work with either)
    (Closes: #681069)

 -- Scott Kitterman <scott@kitterman.com>  Mon, 23 Jul 2012 22:57:47 -0400

linkchecker (7.9-2) unstable; urgency=low

  * Fix postinstallation script of linkchecker-web. (Closes: #677163)

 -- Bastian Kleineidam <calvin@debian.org>  Tue, 12 Jun 2012 07:33:19 +0200

linkchecker (7.9-1) unstable; urgency=low

  * New upstream release (Closes: #674996)
  * Add missing dependency on python-qt4-sql for linkchecker-gui.
  * Standards version 3.9.3.1
  * Suggest python-meliae for memory debugging.

 -- Bastian Kleineidam <calvin@debian.org>  Mon, 11 Jun 2012 07:17:23 +0200

linkchecker (7.8-1) unstable; urgency=low

  * New upstream release.

 -- Bastian Kleineidam <calvin@debian.org>  Sun, 29 Apr 2012 10:32:16 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                python-all-dev (>= 2.7),
                qt4-dev-tools
 X-Python-Version: >= 2.7
-Standards-Version: 3.9.3
+Standards-Version: 3.9.3.1
 Homepage: http://linkchecker.sourceforge.net/
 Vcs-Git: git://linkchecker.git.sourceforge.net/gitroot/linkchecker/linkchecker
 Vcs-Browser: http://linkchecker.git.sourceforge.net/
@@ -18,12 +18,13 @@
 Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
 Provides: ${python:Provides}
 Conflicts: python-dnspython
-Suggests: apache2 | httpd,
-          clamav-daemon,
+Suggests: clamav-daemon,
           linkchecker-gui,
+          linkchecker-web,
           python-cssutils,
           python-gconf,
           python-geoip (>= 1.2.1-2),
+          python-meliae,
           python-optcomplete (>= 1.2-5),
           python-pysqlite2,
           python-twill,
@@ -49,11 +50,32 @@
  Users preferring a graphical interface can install the linkchecker-gui
  package.
 
+Package: linkchecker-web
+Architecture: all
+Depends: linkchecker,
+         apache2 | httpd,
+         libapache2-mod-wsgi | httpd-wsgi,
+         ${misc:Depends},
+         ${python:Depends}
+Conflicts: linkchecker (<< 7.7)
+Description: check websites and HTML documents for broken links (web client)
+ Provides a web interface to check links of websites and HTML documents.
+ Features:
+  o recursive checking
+  o multithreaded
+  o HTTP/1.1, HTTPS, FTP, mailto:, news:, nntp:, Telnet and local file
+    links support
+  o proxy support
+  o username/password authorization for HTTP, FTP and Telnet
+  o robots.txt exclusion protocol support
+  o i18n support
+
 Package: linkchecker-gui
 Architecture: all
 Depends: libqt4-sql-sqlite,
          linkchecker,
          python-qt4 (>= 4.5),
+         python-qt4-sql,
          ${misc:Depends},
          ${python:Depends}
 Recommends: python-qscintilla2

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_HARDENING=1

%:
	dh $@ --with python2

override_dh_auto_configure:
# make sure docs are generated and the manifest is built
	$(MAKE) locale
	$(MAKE) -C doc/html all
	python setup.py sdist --manifest-only

override_dh_auto_build:
# force usage of setup.py over Makefile
	dh_auto_build --buildsystem python_distutils

override_dh_installchangelogs:
# install custom changelog
	dh_installchangelogs doc/changelog.txt


ROOTDIR=$(CURDIR)/debian/linkchecker
LOCALEDIR=$(ROOTDIR)/usr/share/locale
ETCDIR=$(ROOTDIR)/etc

ROOTDIRWEB=$(CURDIR)/debian/linkchecker-web
HTMLDIRWEB=$(ROOTDIRWEB)/usr/share/linkchecker/lconline
CGIDIRWEB=$(ROOTDIRWEB)/usr/lib/cgi-bin
ETCDIRWEB=$(ROOTDIRWEB)/etc

override_dh_auto_install-arch:
	dh_auto_install --buildsystem python_distutils
# install system wide configuration files in etc
	install -m 644 config/linkcheckerrc $(ETCDIR)/linkchecker/
# install bash_completion script
	install -m 644 config/linkchecker-completion $(ETCDIR)/bash_completion.d
# install .mo files
	install -m 644 build/share/locale/de/LC_MESSAGES/linkchecker.mo $(LOCALEDIR)/de/LC_MESSAGES/

override_dh_auto_install-indep:
# install CGI files in web package
	install -m 644 cgi-bin/lconline/*.html $(HTMLDIRWEB)
	install -m 644 cgi-bin/lconline/*.de $(HTMLDIRWEB)
	install -m 644 cgi-bin/lconline/*.en $(HTMLDIRWEB)
	install -m 644 cgi-bin/lconline/*.js $(HTMLDIRWEB)
	install -m 644 cgi-bin/lconline/*.css $(HTMLDIRWEB)
	install -m 644 cgi-bin/lconline/*.ico $(HTMLDIRWEB)
	install -m 755 cgi-bin/lc.wsgi $(CGIDIRWEB)
# apache configuration
	install -m 644 config/linkchecker.apache2.conf $(ETCDIRWEB)/apache2/conf-available/linkchecker.conf

# clean generated files
override_dh_clean:
	dh_clean doc/html/*.qch doc/html/*.qhc _LinkChecker_configdata.py

# do not run test suite when building
override_dh_auto_test:

## linkchecker 8.1

=== Makefile ===
# This Makefile is only used by developers.
PYVER:=2.7
PYTHON?=python$(PYVER)
APPNAME:=LinkChecker
VERSION:=$(shell $(PYTHON) setup.py --version)
PLATFORM:=$(shell $(PYTHON) -c "from distutils.util import get_platform; print get_platform()")
FILESCHECK_URL:=http://localhost/~calvin/
PYTHONSRC:=${HOME}/src/cpython-hg/Lib
#PYTHONSRC:=/usr/lib/$(PYTHON)
SF_FILEPATH=/home/frs/project/l/li/linkchecker
PY_FILES_DIRS:=linkcheck tests *.py linkchecker linkchecker-nagios linkchecker-gui cgi-bin config doc
TESTS ?= tests
# set test options, eg. to "--verbose"
TESTOPTS=
PAGER ?= less
# build dir for debian package
BUILDDIR:=$(HOME)/projects/debian/official
DEB_ORIG_TARGET:=$(BUILDDIR)/linkchecker_$(VERSION).orig.tar.xz
# original dnspython repository module
DNSPYTHON:=$(HOME)/src/dnspython-git
# options to run the pep8 utility
PEP8OPTS:=--repeat --ignore=E211,E501,E225,E301,E302,E241 \
   --exclude="gzip2.py,httplib2.py,robotparser2.py"
PY2APPOPTS ?=
ifeq ($(shell uname),Darwin)
  CHMODMINUSMINUS:=
  NUMPROCESSORS:=$(shell sysctl -n hw.ncpu)
else
  CHMODMINUSMINUS:=--
  NUMPROCESSORS:=$(shell grep -c processor /proc/cpuinfo)
endif
# Pytest options:
# - use multiple processors
# - write test results in file
# - run all tests found in the "tests" subdirectory
PYTESTOPTS:=-n $(NUMPROCESSORS) --resultlog=testresults.txt


all:
	@echo "Read the file doc/install.txt to see how to build and install this package."

clean:
	-$(PYTHON) setup.py clean --all
	rm -f linkchecker-out.* *-stamp*
	$(MAKE) -C po clean
	$(MAKE) -C doc/html clean
	$(MAKE) -C linkcheck/HtmlParser clean
	rm -f linkcheck/network/_network*.so
	find . -name '*.py[co]' -exec rm -f {} \;

distclean: clean cleandeb
	rm -rf build dist $(APPNAME).egg-info
	rm -f _$(APPNAME)_configdata.py MANIFEST Packages.gz
# clean aborted dist builds and -out files
	rm -f linkchecker-out* linkchecker.prof
	rm -f alexa*.log testresults.txt
	rm -rf $(APPNAME)-$(VERSION)
	rm -rf coverage dist-stamp python-build-stamp*

cleandeb:
	rm -rf debian/linkchecker debian/tmp
	rm -f debian/*.debhelper debian/{files,substvars}
	rm -f configure-stamp build-stamp

MANIFEST: MANIFEST.in setup.py
	$(PYTHON) setup.py sdist --manifest-only

locale:
	$(MAKE) -C po mofiles

# to build in the current directory
localbuild: MANIFEST locale
	$(MAKE) -C doc/html
	$(MAKE) -C linkcheck/HtmlParser
	$(PYTHON) setup.py build
	cp -f build/lib.$(PLATFORM)-$(PYVER)/linkcheck/HtmlParser/htmlsax*.so linkcheck/HtmlParser
	cp -f build/lib.$(PLATFORM)-$(PYVER)/linkcheck/network/_network*.so linkcheck/network

deb_orig:
	if [ ! -e $(DEB_ORIG_TARGET) ]; then \
	  cp dist/$(APPNAME)-$(VERSION).tar.xz $(DEB_ORIG_TARGET); \
	fi

upload: dist/README.md
	rsync -avP -e ssh dist/* calvin,linkchecker@frs.sourceforge.net:$(SF_FILEPATH)/$(VERSION)/

login:
# login to SSH shell
	ssh -t sf-linkchecker create

dist/README.md: doc/README-Download.md.tmpl doc/changelog.txt
# copying readme for sourceforge downloads
	sed -e 's/{APPNAME}/$(APPNAME)/g' -e 's/{VERSION}/$(VERSION)/g' $< > $@
# append changelog
	awk '/released/ {c++}; c==2 {exit}; {print "    " $$0}' doc/changelog.txt >> $@

release: distclean releasecheck filescheck clean dist-stamp sign_distfiles upload
	git tag v$(VERSION)
	$(MAKE) homepage
	$(MAKE) register
	$(MAKE) announce

homepage:
	@echo "Updating $(APPNAME) Homepage..."
	$(MAKE) -C doc man
	sed -i -e "s/version = '.*'/version = '$(VERSION)'/" ~/public_html/linkchecker.sf.net/source/conf.py
	$(MAKE) -C ~/public_html/linkchecker.sf.net update upload
	@echo "done."

register:
	@echo "Register at Python Package Index..."
	$(PYTHON) setup.py register
	@echo "done."

announce:
	@echo "Submitting to Freecode..."
	freecode-submit < linkchecker.freecode
	@echo "done."

chmod:
	-chmod -R a+rX,u+w,go-w $(CHMODMINUSMINUS) *
	find . -type d -exec chmod 755 {} \;

dist: locale MANIFEST chmod
	rm -f dist/$(APPNAME)-$(VERSION).tar.xz
	$(PYTHON) setup.py sdist --formats=tar
	xz dist/$(APPNAME)-$(VERSION).tar
# no rpm buildable with bdist_rpm, presumable due to this bug:
# https://bugzilla.redhat.com/show_bug.cgi?id=236535
# too uninvolved to fix it

dist-stamp: changelog
	$(MAKE) dist
	touch $@

# Build OSX installer with py2app
app: distclean localbuild chmod
	$(PYTHON) setup.py py2app $(PY2APPOPTS)

# Build RPM installer with cx_Freeze
rpm:
	$(MAKE) -C doc/html
	$(MAKE) -C linkcheck/HtmlParser
	$(PYTHON) setup.py bdist_rpm

# The check programs used here are mostly local scripts on my private system.
# So for other developers there is no need to execute this target.
check:
	[ ! -d .svn ] || check-nosvneolstyle -v
	check-copyright
	check-pofiles -v
	py-tabdaddy
	py-unittest2-compat tests/
	$(MAKE) doccheck
	$(MAKE) pyflakes

doccheck:
	py-check-docstrings --force linkcheck/HtmlParser linkcheck/checker \
	  linkcheck/cache linkcheck/configuration linkcheck/director \
	  linkcheck/htmlutil linkcheck/logger linkcheck/network \
	  linkcheck/bookmarks \
	  linkcheck/gui/__init__.py \
	  linkcheck/gui/checker.py \
	  linkcheck/gui/contextmenu.py \
	  linkcheck/gui/debug.py \
	  linkcheck/gui/editor.py \
	  linkcheck/gui/editor_qsci.py \
	  linkcheck/gui/editor_qt.py \
	  linkcheck/gui/lineedit.py \
	  linkcheck/gui/help.py \
	  linkcheck/gui/logger.py \
	  linkcheck/gui/options.py \
	  linkcheck/gui/properties.py \
	  linkcheck/gui/settings.py \
	  linkcheck/gui/statistics.py \
	  linkcheck/gui/syntax.py \
	  linkcheck/gui/updater.py \
	  linkcheck/gui/urlmodel.py \
	  linkcheck/gui/urlsave.py \
	  $(filter-out %2.py,$(wildcard linkcheck/*.py)) \
	  cgi-bin/lc.wsgi \
	  linkchecker \
	  linkchecker-gui \
	  linkchecker-nagios \
	  *.py

filescheck: localbuild
	for out in text html gml sql csv xml gxml dot sitemap; do \
	  ./linkchecker -o$$out -F$$out --complete -r1 -C $(FILESCHECK_URL) || exit 1; \
	done

update-copyright:
	update-copyright --holder="Bastian Kleineidam"

releasecheck: check
	@if egrep -i "xx\.|xxxx|\.xx" doc/changelog.txt > /dev/null; then \
	  echo "Could not release: edit doc/changelog.txt release date"; false; \
	fi
	@if ! grep "Version: $(VERSION)" linkchecker.freecode > /dev/null; then \
	  echo "Could not release: edit linkchecker.freecode version"; false; \
	fi
	$(PYTHON) setup.py check --restructuredtext

sign_distfiles:
	for f in $(shell find dist -name *.xz -o -name *.exe -o -name *.zip -o -name *.dmg); do \
	  [ -f $${f}.asc ] || gpg --detach-sign --armor $$f; \
	done

test:	localbuild
	$(PYTHON) -m pytest $(PYTESTOPTS) $(TESTOPTS) $(TESTS)

pyflakes:
	pyflakes $(PY_FILES_DIRS) 2>&1 | \
          grep -v -E "redefinition of unused '(StringIO|Editor|ContentTypeLexers)'" | \
          grep -v "local variable 'dummy' is assigned to but never used" | \
          grep -v -E "'(py2exe|py2app|PyQt4|biplist|setuptools|win32com|find_executable|parse_bookmark_data|parse_bookmark_file|wsgiref|pyftpdlib|linkchecker_rc)' imported but unused" | \
          grep -v -E "redefinition of unused '(setup|Distribution|build)'" | \
          grep -v "undefined name '_'" | \
	  grep -v "undefined name '_n'" | cat

pep8:
	pep8 $(PEP8OPTS) $(PY_FILES_DIRS)

# Compare custom Python files with the original ones from subversion.
diff:
	@for f in gzip robotparser httplib; do \
	  echo "Comparing $${f}.py"; \
	  diff -u linkcheck/$${f}2.py $(PYTHONSRC)/$${f}.py | $(PAGER); \
	done

# Compare dnspython files with the ones from upstream repository
dnsdiff:
	@(for d in dns tests; do \
	  diff -BurN --exclude=*.pyc third_party/dnspython/$$d $(DNSPYTHON)/$$d; \
	done) | $(PAGER)

changelog:
	sftrack_changelog linkchecker calvin@users.sourceforge.net doc/changelog.txt $(DRYRUN)

gui:
	$(MAKE) -C linkcheck/gui

count:
	@sloccount linkchecker linkchecker-gui linkchecker-nagios linkcheck | grep "Total Physical Source Lines of Code"

# run eclipse ide
ide:
	eclipse -data $(CURDIR)/..

.PHONY: test changelog gui count pyflakes ide login upload all clean distclean
.PHONY: pep8 cleandeb locale localbuild deb_orig diff dnsdiff sign_distfiles
.PHONY: filescheck update-copyright releasecheck check register announce
.PHONY: chmod dist app rpm release homepage

=== doc/Makefile ===
--- 
+++ 
@@ -12,15 +12,15 @@
 man:	$(MANFILES)
 
 $(HTMLDIR)/man1/linkchecker.1.html: en/linkchecker.1 linkchecker.1.html.diff
-	man2html -r $< | tail -n +2 | sed 's/Time:.*//g' > $@
+	man2html -r $< | tail -n +2 | sed 's/Time:.*//g' | sed 's@/:@/@g' > $@
 	patch --no-backup-if-mismatch --quiet $@ linkchecker.1.html.diff
 
 $(HTMLDIR)/man5/linkcheckerrc.5.html: en/linkcheckerrc.5 linkcheckerrc.5.html.diff
-	man2html -r $< | tail -n +2 | sed 's/Time:.*//g' > $@
+	man2html -r $< | tail -n +2 | sed 's/Time:.*//g' | sed 's@/:@/@g' > $@
 	patch --no-backup-if-mismatch --quiet $@ linkcheckerrc.5.html.diff
 
 $(HTMLDIR)/man1/linkchecker-gui.1.html: en/linkchecker-gui.1 linkchecker-gui.1.html.diff
-	man2html -r $< | tail -n +2 | sed 's/Time:.*//g' > $@
+	man2html -r $< | tail -n +2 | sed 's/Time:.*//g' | sed 's@/:@/@g' > $@
 	patch --no-backup-if-mismatch --quiet $@ linkchecker-gui.1.html.diff
 
 .PHONY: po4a man

=== debian/changelog ===
linkchecker (8.1-1) unstable; urgency=low

  * New upstream release.

 -- Bastian Kleineidam <calvin@debian.org>  Sun, 14 Oct 2012 20:48:03 +0200

linkchecker (8.0-1) unstable; urgency=low

  * New upstream release.
  * Require Python >= 2.7.2
  * Upstream fixed bug #681069 (thanks for NMUing).

 -- Bastian Kleineidam <calvin@debian.org>  Sun, 02 Sep 2012 23:47:00 +0200

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 Package: linkchecker
 Architecture: any
-Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}, python (>= 2.7.2)
 Provides: ${python:Provides}
 Conflicts: python-dnspython
 Suggests: clamav-daemon,

## linkchecker 8.2

=== Makefile ===
--- 
+++ 
@@ -73,8 +73,8 @@
 	$(MAKE) -C doc/html
 	$(MAKE) -C linkcheck/HtmlParser
 	$(PYTHON) setup.py build
-	cp -f build/lib.$(PLATFORM)-$(PYVER)/linkcheck/HtmlParser/htmlsax*.so linkcheck/HtmlParser
-	cp -f build/lib.$(PLATFORM)-$(PYVER)/linkcheck/network/_network*.so linkcheck/network
+	cp -f build/lib.$(PLATFORM)-$(PYVER)*/linkcheck/HtmlParser/htmlsax*.so linkcheck/HtmlParser
+	cp -f build/lib.$(PLATFORM)-$(PYVER)*/linkcheck/network/_network*.so linkcheck/network
 
 deb_orig:
 	if [ ! -e $(DEB_ORIG_TARGET) ]; then \
@@ -129,7 +129,7 @@
 # https://bugzilla.redhat.com/show_bug.cgi?id=236535
 # too uninvolved to fix it
 
-dist-stamp: changelog
+dist-stamp: changelog config/ca-certificates.crt
 	$(MAKE) dist
 	touch $@
 
@@ -151,6 +151,7 @@
 	check-pofiles -v
 	py-tabdaddy
 	py-unittest2-compat tests/
+	$(MAKE) -C doc check
 	$(MAKE) doccheck
 	$(MAKE) pyflakes
 
@@ -199,6 +200,9 @@
 	@if ! grep "Version: $(VERSION)" linkchecker.freecode > /dev/null; then \
 	  echo "Could not release: edit linkchecker.freecode version"; false; \
 	fi
+	@if grep "UNRELEASED" debian/changelog > /dev/null; then \
+	  echo "Could not release: edit debian/changelog distribution name"; false; \
+	fi
 	$(PYTHON) setup.py check --restructuredtext
 
 sign_distfiles:
@@ -247,7 +251,12 @@
 ide:
 	eclipse -data $(CURDIR)/..
 
+update-certificates:	config/ca-certificates.crt
+
+config/ca-certificates.crt:	/etc/ssl/certs/ca-certificates.crt
+	cp $< $@
+
 .PHONY: test changelog gui count pyflakes ide login upload all clean distclean
 .PHONY: pep8 cleandeb locale localbuild deb_orig diff dnsdiff sign_distfiles
 .PHONY: filescheck update-copyright releasecheck check register announce
-.PHONY: chmod dist app rpm release homepage
+.PHONY: chmod dist app rpm release homepage update-certificates

=== doc/Makefile ===
--- 
+++ 
@@ -1,15 +1,18 @@
 HTMLDIR:=$(HOME)/public_html/linkchecker.sf.net/source
-MANFILES:= \
+MANHTMLFILES:= \
 	$(HTMLDIR)/man1/linkchecker.1.html \
 	$(HTMLDIR)/man5/linkcheckerrc.5.html \
 	$(HTMLDIR)/man1/linkchecker-gui.1.html
+
+MANFILES:=linkchecker.1 linkcheckerrc.5 linkchecker-gui.1
+LOCALES:=en de
 
 all:
 
 po4a:
 	po4a --localized-charset=UTF-8 po4a.conf
 
-man:	$(MANFILES)
+man:	$(MANHTMLFILES)
 
 $(HTMLDIR)/man1/linkchecker.1.html: en/linkchecker.1 linkchecker.1.html.diff
 	man2html -r $< | tail -n +2 | sed 's/Time:.*//g' | sed 's@/:@/@g' > $@
@@ -23,4 +26,15 @@
 	man2html -r $< | tail -n +2 | sed 's/Time:.*//g' | sed 's@/:@/@g' > $@
 	patch --no-backup-if-mismatch --quiet $@ linkchecker-gui.1.html.diff
 
-.PHONY: po4a man
+# check all makefiles for formatting warnings
+check:
+	@t=$(shell tempfile); \
+	for loc in $(LOCALES); do \
+	  for manfile in $(MANFILES); do \
+	    echo "Checking $$loc/$$manfile"; \
+	    LC_ALL=en_US.UTF-8 MANWIDTH=80 man --warnings -E UTF-8 -l $$loc/$$manfile > /dev/null 2>$$t ; \
+	    if [ -s $$t ]; then cat $$t; exit 1; fi; \
+	  done; \
+	done
+
+.PHONY: po4a man check

=== doc/html/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 HELPFILES := lccollection.qhc
-HTMLFILES := index.html options.html
+HTMLFILES := index.html
 OXYGEN := ${HOME}/src/oxygen-gitsvn
 ICOICONS := logo16x16.png logo32x32.png
 ICNSICONS := logo16x16.png logo32x32.png logo48x48.png logo128x128.png
